<template>
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-1 col-lg-2 navbar-container" style="background-color: #121212">
                <nav class="navbar navbar-expand-md navbar-dark w-100">
                    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                    </button>
                    <div class="collapse navbar-collapse" id="navbar">
                        <ul class="navbar-nav">
                            <li class="nav-item navigation">
                                <router-link class="nav-link text-white mt-2" :to="{ name: 'home' }">
                                    <strong>
                                        <svg xmlns="http://www.w3.org/2000/svg" width="18" height="18" fill="currentColor" class="bi bi-house-door-fill text-white mb-2" viewBox="0 0 16 16">
                                            <path d="M6.5 14.5v-3.505c0-.245.25-.495.5-.495h2c.25 0 .5.25.5.5v3.5a.5.5 0 0 0 .5.5h4a.5.5 0 0 0 .5-.5v-7a.5.5 0 0 0-.146-.354L13 5.793V2.5a.5.5 0 0 0-.5-.5h-1a.5.5 0 0 0-.5.5v1.293L8.354 1.146a.5.5 0 0 0-.708 0l-6 6A.5.5 0 0 0 1.5 7.5v7a.5.5 0 0 0 .5.5h4a.5.5 0 0 0 .5-.5z"/>
                                        </svg>
                                        Home
                                    </strong>
                                </router-link>
                                <hr>
                            </li>

                            <li class="nav-item navigation">
                                <router-link class="nav-link text-white" :to="{ name: 'top' }"><strong>Top</strong></router-link>
                            </li>
                            <li class="nav-item navigation">
                                <router-link class="nav-link text-white" :to="{ name: 'search' }">
                                    <strong>
                                        Search
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-search text-white ml-2" viewBox="0 0 16 16">
                                            <path d="M11.742 10.344a6.5 6.5 0 1 0-1.397 1.398h-.001c.03.04.062.078.098.115l3.85 3.85a1 1 0 0 0 1.415-1.414l-3.85-3.85a1.007 1.007 0 0 0-.115-.1zM12 6.5a5.5 5.5 0 1 1-11 0 5.5 5.5 0 0 1 11 0z"/>
                                        </svg>
                                    </strong>
                                </router-link>
                            </li>
                            <li class="nav-item navigation">
                                <router-link class="nav-link text-white" :to="{ name: 'playlists' }">
                                    <strong>
                                        Your Library
                                        <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill="currentColor" class="bi bi-music-note-list ml-2" viewBox="0 0 16 16">
                                            <path d="M12 13c0 1.105-1.12 2-2.5 2S7 14.105 7 13s1.12-2 2.5-2 2.5.895 2.5 2z"/>
                                            <path fill-rule="evenodd" d="M12 3v10h-1V3h1z"/>
                                            <path d="M11 2.82a1 1 0 0 1 .804-.98l3-.6A1 1 0 0 1 16 2.22V4l-5 1V2.82z"/>
                                            <path fill-rule="evenodd" d="M0 11.5a.5.5 0 0 1 .5-.5H4a.5.5 0 0 1 0 1H.5a.5.5 0 0 1-.5-.5zm0-4A.5.5 0 0 1 .5 7H8a.5.5 0 0 1 0 1H.5a.5.5 0 0 1-.5-.5zm0-4A.5.5 0 0 1 .5 3H8a.5.5 0 0 1 0 1H.5a.5.5 0 0 1-.5-.5z"/>
                                        </svg>
                                    </strong>
                                </router-link>
                            </li>
                            <li class="nav-item navigation">
                                <router-link class="nav-link text-white" :to="{ name: 'favorites' }">
                                    <strong>Favorites
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-star-fill mb-1 ml-2" viewBox="0 0 16 16">
                                            <path d="M3.612 15.443c-.386.198-.824-.149-.746-.592l.83-4.73L.173 6.765c-.329-.314-.158-.888.283-.95l4.898-.696L7.538.792c.197-.39.73-.39.927 0l2.184 4.327 4.898.696c.441.062.612.636.282.95l-3.522 3.356.83 4.73c.078.443-.36.79-.746.592L8 13.187l-4.389 2.256z"/>
                                        </svg>
                                    </strong>
                                </router-link>
                            </li>

                            <hr style="border-top: 1px solid white; margin-top: 50px">

                            <li class="nav-item">
                                <div class="footer">
                                    <div class="text-white marquee">
                                        <span class="text-white mt-2">{{ currentSong.title }}</span>
                                    </div>
                                    <div class="row">
                                        <div class="col-3 col-sm-3 col-md-6 col-lg-3 text-right text-white">
<!--RAND-->
                                            <svg xmlns="http://www.w3.org/2000/svg" width="15" height="15" fill="currentColor" class="bi bi-shuffle randIcon " viewBox="0 0 16 16">
                                                <path fill-rule="evenodd" d="M0 3.5A.5.5 0 0 1 .5 3H1c2.202 0 3.827 1.24 4.874 2.418.49.552.865 1.102 1.126 1.532.26-.43.636-.98 1.126-1.532C9.173 4.24 10.798 3 13 3v1c-1.798 0-3.173 1.01-4.126 2.082A9.624 9.624 0 0 0 7.556 8a9.624 9.624 0 0 0 1.317 1.918C9.828 10.99 11.204 12 13 12v1c-2.202 0-3.827-1.24-4.874-2.418A10.595 10.595 0 0 1 7 9.05c-.26.43-.636.98-1.126 1.532C4.827 11.76 3.202 13 1 13H.5a.5.5 0 0 1 0-1H1c1.798 0 3.173-1.01 4.126-2.082A9.624 9.624 0 0 0 6.444 8a9.624 9.624 0 0 0-1.317-1.918C4.172 5.01 2.796 4 1 4H.5a.5.5 0 0 1-.5-.5z"/>
                                                <path d="M13 5.466V1.534a.25.25 0 0 1 .41-.192l2.36 1.966c.12.1.12.284 0 .384l-2.36 1.966a.25.25 0 0 1-.41-.192zm0 9v-3.932a.25.25 0 0 1 .41-.192l2.36 1.966c.12.1.12.284 0 .384l-2.36 1.966a.25.25 0 0 1-.41-.192z"/>
                                            </svg>
                                            <br>
                                            <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill="currentColor" class="bi bi-dot" viewBox="0 0 16 16">
                                                <path d="M8 9.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3z"/>
                                            </svg>
                                        </div>
<!--PREV-->
                                        <div class="col-2 col-sm-4 col-md-4 col-lg-2 text-right text-white">
                                            <h5 class="prevIcon" @click="prev">&#x23ea;</h5>
                                        </div>
<!--PLAY/PAUSE-->
                                        <div class="col-2 col-sm-4 col-md-4 col-lg-2 text-center text-white">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" fill="currentColor" class="bi bi-play playIcon" v-if="!isPlaying" @click="play()" viewBox="0 0 16 16">
                                                <path d="M10.804 8 5 4.633v6.734L10.804 8zm.792-.696a.802.802 0 0 1 0 1.392l-6.363 3.692C4.713 12.69 4 12.345 4 11.692V4.308c0-.653.713-.998 1.233-.696l6.363 3.692z"/>
                                            </svg>
                                            <svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" fill="currentColor" v-else @click="pause" class="bi bi-pause pauseIcon" viewBox="0 0 16 16">
                                                <path d="M6 3.5a.5.5 0 0 1 .5.5v8a.5.5 0 0 1-1 0V4a.5.5 0 0 1 .5-.5zm4 0a.5.5 0 0 1 .5.5v8a.5.5 0 0 1-1 0V4a.5.5 0 0 1 .5-.5z"/>
                                            </svg>
                                        </div>
<!--NEXT-->
                                        <div class="col-2 col-sm-4 col-md-4 col-lg-2 text-left text-white">
                                            <h5 class="nextIcon" @click="next">&#x23e9;</h5>
                                        </div>
<!--REPEAT-->
                                        <div class="col-3 col-sm-3 col-md-6 col-lg-3 text-left text-white">
                                            <svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" fill="currentColor" class="bi bi-arrow-repeat repeatIcon" viewBox="0 0 16 16">
                                                <path d="M11.534 7h3.932a.25.25 0 0 1 .192.41l-1.966 2.36a.25.25 0 0 1-.384 0l-1.966-2.36a.25.25 0 0 1 .192-.41zm-11 2h3.932a.25.25 0 0 0 .192-.41L2.692 6.23a.25.25 0 0 0-.384 0L.342 8.59A.25.25 0 0 0 .534 9z"/>
                                                <path fill-rule="evenodd" d="M8 3c-1.552 0-2.94.707-3.857 1.818a.5.5 0 1 1-.771-.636A6.002 6.002 0 0 1 13.917 7H12.9A5.002 5.002 0 0 0 8 3zM3.1 9a5.002 5.002 0 0 0 8.757 2.182.5.5 0 1 1 .771.636A6.002 6.002 0 0 1 2.083 9H3.1z"/>
                                            </svg>
                                        </div>
                                    </div>
                                </div>
                            </li>
                        </ul>
                    </div>
                </nav>
            </div>

            <div class="col-md-8 col-lg-9 content-container">
                <div class="text-white mt-5 ml-2" style="height: 800px;">
                    <transition name="slide-fade">
                        <router-view @play="play" @playAll="playAll" @pause="pause" :playing="isPlaying" :activeSong="currentSong.id"></router-view>
                    </transition>
                </div>
            </div>

        </div>
    </div>
</template>

<script>
export default {
    name: "MainComponent",

    comments: ['player'],

    data() {
        return {
            pager: {},
            index: 0,
            indexCurrentPage: 1,
            isPlaying: false,
            currentTime: '',
            player: new Audio(),
            repeat: false,
            active_btn: 0,
            show: false,
            lastVol: 0,
            current: [],
            // songs: [],
            current_playlist: []
        }
    },

    computed: {
        songs(){
            return this.pager || [];
        },
        // currentPage(){
        //     return this.indexCurrentPage = this.pager.current_page;
        // }
        currentSong(){
            return this.songs[this.index] || 'no track'
        },
        currentPlaylist(){
            return this.current_playlist || 'no playlist'
        }
    },

    // beforeDestroy () {
    //     clearInterval();
    // },

    methods: {
        // getPlayList(page = 1){
        //     axios
        //         .get('/api/play-list?page=' + page)
        //         .then(({data}) => {
        //             this.pager = data;
        //         })
        //         .catch(error => console.log(error.response.data));
        // },

        // getTimeOfTrack(time){
        //     let minutes = Math.floor(time / 60);
        //     let seconds = time - minutes * 60;
        //     if (parseInt(seconds) < 10){
        //         this.currentTime = minutes + ':0' + parseInt(seconds);
        //     }
        //     else {
        //         this.currentTime = minutes + ':' + parseInt(seconds);
        //     }
        // },

        // repeatTrack(){
        //     this.repeat = !this.repeat;
        //     this.player.loop = this.repeat;
        // },

        play(data = []){

            if (data.length !== 0){
                if(this.player.src === '' || this.current.path !== data.current.path){

                    this.index = data.songs.indexOf(data.current);
                    this.pager = data.songs;

                    this.player.src = this.currentSong.path;
                }
            }

            this.active_btn = this.currentSong.id;

            // setInterval(() => this.getTimeOfTrack(this.player.currentTime), 50);

            if (this.isPlaying && this.active_btn === this.current.id){
                this.player.pause();
            }

            if(this.player.src !== ''){
                this.player.play();
                this.isPlaying = true;
            }

            this.player.addEventListener('ended', function (){
                if(this.player.ended) {
                    this.player.src = this.currentSong.path;
                    this.next();
                    this.isPlaying = false;
                }
            }.bind(this));
        },

        playAll(data){
            axios
                .get('/api/get/'+data.playlistId+'/songs')
                .then(({data}) => {
                    if(data.songs.length !== 0){
                        if(this.player.src === '' || this.current.path !== data.songs[0].path){
                            this.pager = data.songs;
                            this.index = 0;
                            this.player.src = this.songs[this.index].path;
                        }
                    }

                    this.player.play();

                    this.isPlaying = true;
                })
                .catch(error => console.log(error.response.data));
        },

        getPlaylistSongs(id){
            axios
                .get('/api/get/'+id+'/songs')
                .then(({data}) => {
                    this.songs = data.songs;
                })
                .catch(error => console.log(error.response.data));
        },

        pause(){
            this.player.pause();
            this.isPlaying = false;
        },

        next(){
            this.player.pause();
            this.index++;
            if(this.index > this.songs.length-1){
                this.index = 0;
            }
            this.active_btn = this.currentSong.id;
            setTimeout(() => this.play({ current: this.currentSong, songs: this.songs }), 500);
        },

        prev(){
            this.index--;
            if(this.index < 0){
                this.index = this.songs.length-1;
            }
            this.play({ current: this.currentSong, songs: this.songs });
        },

        // durationForUser(time){
        //     let minutes = Math.floor(time / 60);
        //     let seconds = time - minutes * 60;
        //     let sep;
        //
        //     parseInt(seconds) < 10 ? sep = ':0' : sep = ':';
        //
        //     return minutes + sep + parseInt(seconds);
        // },
        //
        // mute(lastVol){
        //     this.lastVol = lastVol;
        //     this.player.volume = 0;
        // }
    },

    updated(){

    }
}
</script>

<style scopped>
    .footer {
        position: absolute;
        left: 0;
        bottom: 10%;
        width: 100%;
        border-top: solid 1px #303030;
        text-align: center;
        margin-bottom: 0;

        .min-width: 200px;
    }
</style>
